Prepare local sector variable (offset) for later patch.
Do not update io->sector for still running io.

No functional change.

Signed-off-by: Milan Broz <mbroz@redhat.com>
---
 drivers/md/dm-crypt.c |    7 +++++--
 1 files changed, 5 insertions(+), 2 deletions(-)

Index: linux/drivers/md/dm-crypt.c
===================================================================
--- linux.orig/drivers/md/dm-crypt.c	2008-08-04 14:40:13.000000000 +0100
+++ linux/drivers/md/dm-crypt.c	2008-08-04 14:40:15.000000000 +0100
@@ -686,7 +686,6 @@ static void kcryptd_crypt_write_io_submi
 	BUG_ON(io->ctx.idx_out < clone->bi_vcnt);
 
 	clone->bi_sector = cc->start + io->sector;
-	io->sector += bio_sectors(clone);
 
 	if (async)
 		kcryptd_queue_io(io);
@@ -700,13 +699,14 @@ static void kcryptd_crypt_write_convert(
 	struct bio *clone;
 	unsigned crypt_finished, out_of_pages = 0;
 	unsigned remaining = io->base_bio->bi_size;
+	sector_t sector = io->sector;
 	int r;
 
 	/*
 	 * Prevent io from disappearing until this function completes.
 	 */
 	crypt_inc_pending(io);
-	crypt_convert_init(cc, &io->ctx, NULL, io->base_bio, io->sector);
+	crypt_convert_init(cc, &io->ctx, NULL, io->base_bio, sector);
 
 	/*
 	 * The allocated buffers can be smaller than the whole bio,
@@ -723,6 +723,7 @@ static void kcryptd_crypt_write_convert(
 		io->ctx.idx_out = 0;
 
 		remaining -= clone->bi_size;
+		sector += bio_sectors(clone);
 
 		crypt_inc_pending(io);
 
@@ -739,6 +740,8 @@ static void kcryptd_crypt_write_convert(
 			 */
 			if (unlikely(r < 0))
 				break;
+
+			io->sector = sector;
 		}
 
 		/*
